local hr, hg, hb = 0.2, 0.2, 0.2
local pr, pg, pb = hr * 1.5, hg * 1.5, hb * 1.5
local W, H = 113, 15
local settings = oUF_Led2_Settings["Solo&Party"]
local unpack = unpack
local _G = getfenv(0)

local siValue = function(val)
    if val >= 10000000 then 
        return format("%.1fm", val / 1000000) 
    elseif val >= 1000000 then
        return format("%.2fm", val / 1000000) 
    elseif val >= 100000 then
        return format("%.0fk", val / 1000) 
    elseif val >= 10000 then
        return format("%.1fk", val / 1000) 
    else
        return val
    end
end

oUF.Tags['[bossname]'] = function(u)
	return UnitName(u):sub(1, 15)
end

oUF.Tags['[bosshealth]'] = function(u)
	siValue(UnitHealth(u))
end

MakeBG = function(parent)
    local bg = parent:CreateTexture(nil, "BACKGROUND")
    bg:SetPoint("TOPLEFT", parent, -1, 1)
    bg:SetPoint("BOTTOMRIGHT", parent, 1, -1)
    bg:SetTexture(0, 0, 0)
end

MakeFS = function(parent, justify)
    local f = parent:CreateFontString(nil, "OVERLAY")
    f:SetFont(settings.font, settings.fsize, "THINOUTLINE", "MONOCHROME")
    f:SetShadowColor(0, 0, 0, 0)
	f:SetShadowOffset(0,0)
    if(justify) then f:SetJustifyH(justify) end
    return f
end

--[[ Lets Start ]]
local function func(self, unit)
	self:SetScript("OnEnter", UnitFrame_OnEnter)
	self:SetScript("OnLeave", UnitFrame_OnLeave)
	self:SetAttribute("initial-width", W)
	self:SetAttribute("initial-height", H)

	self.bg, self.bd = MakeBG(self)

	--[[ Healthbar ]]
	local hp = CreateFrame("StatusBar", nil, self)
	hp:SetStatusBarTexture(settings.texture)
	hp:SetStatusBarColor(hr, hg, hb)
	hp:SetAllPoints(self)
	hp.frequentUpdates = true

	local hpbg = hp:CreateTexture(nil, "BACKGROUND")
	hpbg:SetTexture(settings.texture)
	hpbg:SetVertexColor(hr, hg, hb, .2)
	hpbg:SetAllPoints(self)

    local info = MakeFS(hp)
	local info2 = MakeFS(hp)
	info:SetPoint("RIGHT", hp, "RIGHT", 0, 0)
    info:SetJustifyH("RIGHT")
    info:SetPoint("RIGHT")
    self:Tag(info, "[bossname] ")
	info2:SetPoint("LEFT", hp, "LEFT", 0, 0)
	info2:SetJustifyH("LEFT")
	info2:SetPoint("LEFT")
	self:Tag(info2, " [bosshealth]")
	
	
	hp.value = hpp
	self.Health = hp

	return self
end

oUF:RegisterStyle("led2boss", func)
oUF:SetActiveStyle("led2boss")

for i = 1, 4 do
	_G["Boss"..i.."TargetFrame"]:UnregisterAllEvents()
	_G["Boss"..i.."TargetFrame"].Show = dummy
	_G["Boss"..i.."TargetFrame"]:Hide()
 	_G["Boss"..i.."TargetFrame".."HealthBar"]:UnregisterAllEvents()
	_G["Boss"..i.."TargetFrame".."ManaBar"]:UnregisterAllEvents()

	oUF:Spawn('boss'..i, 'oUF_boss'..i):SetPoint('TOP', i==1 and Minimap or _G['oUF_boss'..i-1], 'BOTTOM', 0, -3)
 end